#ifndef ENUMFINDER_H
#define ENUMFINDER_H

#include <stdexcept>
#include <fstream>
#include <vector>
#include <string>
#include <memory>

using namespace std;

struct Enum
{
    string name;
    vector<string> enumerators;
};

typedef vector<unique_ptr<Enum> > EnumsVector;

class EnumFinder
{
public:
    static unique_ptr<EnumsVector> find(const string &fileName);
           
private:
    EnumFinder() : enums(new EnumsVector) {}
    
    vector<string> nestedNamespaces;
    unique_ptr<EnumsVector> enums;
    unique_ptr<Enum> currentEnum;

    friend class EtoscParser;
    
    void addNestedNamespace(const string &namespaceName) 
         {nestedNamespaces.push_back(namespaceName);}
    void removeNestedNamespace() {nestedNamespaces.pop_back();}
    void startAddingEnum(const string &enumName);
    void endAddingEnum();
    void addEnumerator(const string &enumeratorName);
};

#endif
