lexer grammar EtoscLexer;

@parser::postinclude {
#include <iostream>

using namespace std;
}

tokens {
	CLASS,
    STRUCT,
    NAME_SPACE,
    ENUM,
	WORD,
    ENUMERATOR_VALUE,
	LEFT_BRACE,
	RIGHT_BRACE,
    COMMA,
    SEMICOLON
}

CLASS:          'class';
STRUCT:         'struct';
NAME_SPACE:     'namespace';
ENUM:           'enum' ;

WORD: ('_' | LETTER) ('_' | LETTER | '0'..'9')*;
ENUMERATOR_VALUE: (LETTER | '0'..'9')+;
fragment LETTER : [a-zA-Z];

LEFT_BRACE:     '{';
RIGHT_BRACE:    '}';
COMMA:          ',';
SEMICOLON:      ';';
EQUAL:          '=';

WS: [ \t\r]+ -> skip;
NewLine: [\n] -> skip;
Parentheses:    '(' .*? ')' -> skip;
Templates:      '<' .*? '>' -> skip;
AngleBrackets:  '[' .*? ']' -> skip;
Other: . -> skip;
