parser grammar EtoscParser;

@parser::postinclude {
#include "EnumFinder.h"
}

options {
    tokenVocab = EtoscLexer;
}

@parser::members {
void setEnumFinder(EnumFinder *finder) {enumFinder = finder;}
}

@parser::declarations {
EnumFinder *enumFinder = nullptr;
}

parseFile : (expr)* EOF;

expr : namespace_
     | enum_
     | LEFT_BRACE (expr)* RIGHT_BRACE
     | ~(LEFT_BRACE | RIGHT_BRACE)
     ;
     
namespace_ : namespaceKey WORD LEFT_BRACE  
             {enumFinder->addNestedNamespace($WORD.text);} 
             (expr)+ RIGHT_BRACE
             {enumFinder->removeNestedNamespace();} 
           ;

enum_ : ENUM (classKey)? name=WORD (WORD)? LEFT_BRACE 
        {enumFinder->startAddingEnum($name.text);}
        enumList RIGHT_BRACE
        {enumFinder->endAddingEnum();}
      ;

enumList : enumerator COMMA enumList | enumerator;

enumerator : WORD (EQUAL ENUMERATOR_VALUE)? {enumFinder->addEnumerator($WORD.text);};

namespaceKey : classKey | NAME_SPACE;            
classKey : CLASS | STRUCT;
