#include <iostream>
#include <fstream>

#include "Controller.h"

const char helpStr[] = 
    "Usage: etosc FILE\n"
    "etosc is a tool using for generating methods that convert values of c++11\n"
    "enum to std::strings and backwards.\n"
    "It takes c++11 source file and generates two files: \"etosc.h\" and \"etosc.cpp\".\n"
    "File \"etosc.h\" contains declarations of methods for converting enum values to\n"
    "strings and backwards.\n"
    "File \"etosc.cpp\" contains definitions of these methods for every enum\n"
    "definition found in input file.\n";

using namespace std;

int main(int argc, const char **argv) 
{
    if (argc == 1)
    {
        cout <<  helpStr;
        return -1;
    }

    Controller controller;

    try 
    {
        controller.start(argv[1]);
    }
    catch (exception &e)
    {
        cout << e.what() << endl;

        return -1;
    }
        
    return 0;
}
