#include <stdexcept>

#include "etosc.h"
#include "example.h"

template<>
std::string enumToString(A::C::Color val)
{
    switch (val)
    {
        case A::C::Color::red:
            return "red";

        case A::C::Color::green:
            return "green";

        case A::C::Color::blue:
            return "blue";
    }
}

template<>
A::C::Color stringToEnum(const std::string &str)
{
    if (str == "red")
        return A::C::Color::red;

    if (str == "green")
        return A::C::Color::green;

    if (str == "blue")
        return A::C::Color::blue;

    throw std::runtime_error(std::string("Enum A::C::Color has no "
                                         "enumerator named ") + str);
}

template<>
std::string enumToString(A::Fruits val)
{
    switch (val)
    {
        case A::Fruits::banana:
            return "banana";

        case A::Fruits::apple:
            return "apple";
    }
}

template<>
A::Fruits stringToEnum(const std::string &str)
{
    if (str == "banana")
        return A::Fruits::banana;

    if (str == "apple")
        return A::Fruits::apple;

    throw std::runtime_error(std::string("Enum A::Fruits has no "
                                         "enumerator named ") + str);
}
